Review:
  stage: Deploy
  extends: .auto-deploy
  needs:
    - Build
  rules:
    - if: $CI_COMMIT_TAG
      when: never
    - if: '$CI_COMMIT_BRANCH =~ /^test-.*/ || $CI_COMMIT_BRANCH =~ /^nocicd-.*/ || $REVIEW_DISABLED == "true"'
      when: never
    - if: '$CI_PIPELINE_SOURCE != "push"'
      when: never
    - if: '$CI_COMMIT_BRANCH != "master" && $CI_COMMIT_BRANCH != "staging" && $CI_KUBERNETES_ACTIVE == "true"'
      when: manual
      allow_failure: true
  environment:
    name: review/$CI_COMMIT_REF_NAME
    url: https://$CI_PROJECT_ID-$CI_ENVIRONMENT_SLUG.$KUBE_INGRESS_BASE_DOMAIN
    on_stop: Stop Review
    auto_stop_in: 3 days
    kubernetes:
      namespace: $CI_PROJECT_PATH_SLUG
  before_script:
    - cp -R ./.cicd/chart ./chart
    - export HELM_UPGRADE_VALUES_FILE=".cicd/upgrade-values/auto-deploy-values-review.yaml"
  script:
    - auto-deploy check_kube_domain
    - auto-deploy download_chart
    - auto-deploy ensure_namespace
    - auto-deploy initialize_tiller
    - auto-deploy create_secret
    - auto-deploy deploy
    - auto-deploy persist_environment_url
  artifacts:
    paths: [environment_url.txt]

Stop Review:
  stage: Clean up
  extends: .auto-deploy
  needs:
    - Review
  rules:
    - if: $CI_COMMIT_TAG
      when: never
    - if: '$CI_COMMIT_BRANCH =~ /^test-.*/ || $CI_COMMIT_BRANCH =~ /^nocicd-.*/ || $REVIEW_DISABLED == "true"'
      when: never
    - if: '$CI_PIPELINE_SOURCE != "push"'
      when: never
    - if: '$CI_COMMIT_BRANCH != "master" && $CI_COMMIT_BRANCH != "staging" && $CI_KUBERNETES_ACTIVE == "true"'
      when: manual
      allow_failure: true
  variables:
    GIT_STRATEGY: none
  environment:
    name: review/$CI_COMMIT_REF_NAME
    action: stop
    kubernetes:
      namespace: $CI_PROJECT_PATH_SLUG
  script:
    - auto-deploy initialize_tiller
    - auto-deploy delete
